## Créé le 5/5/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################

##
# Si aucune table n'est spécifiée en argument, il s'agira d'un ajout de table.
# Si une tables est passée en argument, il s'agira alors de l'éditer.
# Pour un ajout, spécifier uniquement les coordonnées.
# Pour une édition, indiquer en coordonnées 0:0 et passer son id
##
proc INTERFACE_ajout_table {x y {id "null"}} {
    global LOCALE
    global coords
    global IMG
    global tables
    global table_tmp
    global id_attribut_graphique
    
    
    set f ".fen_ajout_table"
    
    # Initialise la table temporaire
    if {$id == "null"} {
        # Transfert des coordonnées
        set coords [list $x $y]
        set table_tmp [Katyusha_Tables_init_table]
        dict set table_tmp "coords" $coords
    } else {
        set table [dict get $tables $id]
        set table_tmp $table
        set nom_table [dict get $table "nom"]
    }
    dict set table_tmp "id" $id
    
    set id_attribut_graphique 0
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    # Frame de choix du nom de la table
    frame $f.nom
        label $f.nom.l -text "Nom de la table : "
        entry $f.nom.e -textvariable nom_table
        pack $f.nom.l $f.nom.e -side left
    pack $f.nom -pady 10 -padx 50
    
    frame $f.attributs
        # Commandes des attributs
        frame $f.attributs.commandes
            # Bouton d'ajout d'un nouvel attribut
            button $f.attributs.commandes.ajout -text "+" -image $IMG(ajouter) -command {INTERFACE_ajout_attribut "table"}
            # Bouton de supression d'un nouvel attribut
            button $f.attributs.commandes.supp -text "-" -image $IMG(supprimer) -command {INTERFACE_suppression_attribut "table"}
            pack $f.attributs.commandes.ajout $f.attributs.commandes.supp -padx 10
        pack $f.attributs.commandes -side left -fill x
        # Liste des attributs
        frame $f.attributs.liste
            label $f.attributs.titre -text "Liste des attributs de la table"
            pack $f.attributs.titre -fill x
            frame $f.attributs.tete
                label $f.attributs.tete.nom -text "Nom" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.type -text "Type" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.taille -text "Taille" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.valeur -text "Valeur par défaut" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.auto -text "Incrément?" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.pk -text "Clef primaire?" -width 20 -height 2 -background white -relief solid
                
                pack $f.attributs.tete.nom $f.attributs.tete.type $f.attributs.tete.taille $f.attributs.tete.valeur $f.attributs.tete.auto $f.attributs.tete.pk -fill x -side left
            pack $f.attributs.tete -fill x
            frame $f.attributs.corps
                ##
                # Ici viennent s'insérer les attributs
                ##
                # Si la table est en édition, on affiche la liste des attributs déjà existants
                if {$id != "null"} {
                    set attributs [dict get $table "attributs"]
                    set c 0
                    foreach attribut $attributs {
                        set nom_attribut_graphique [dict get $attribut "nom"]
                        frame $f.attributs.corps.$nom_attribut_graphique
                            label $f.attributs.corps.$nom_attribut_graphique.nom -text [dict get $attribut "nom"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.type -text [dict get $attribut "type"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.taille -text [dict get $attribut "taille"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.valeur -text [dict get $attribut "valeur"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.auto -text [dict get $attribut "auto"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.pk -text [dict get $attribut "pk"] -width 20 -height 2 -background white -relief solid
                            button $f.attributs.corps.$nom_attribut_graphique.edit -text "Éditer" -image $IMG(editer) -command "Katyusha_Tables_modification_attribut $c"
                            pack $f.attributs.corps.$nom_attribut_graphique.nom $f.attributs.corps.$nom_attribut_graphique.type $f.attributs.corps.$nom_attribut_graphique.taille $f.attributs.corps.$nom_attribut_graphique.valeur $f.attributs.corps.$nom_attribut_graphique.auto $f.attributs.corps.$nom_attribut_graphique.pk $f.attributs.corps.$nom_attribut_graphique.edit -side left
                        pack $f.attributs.corps.$nom_attribut_graphique -fill x
                        set id_attribut_graphique [expr $id_attribut_graphique + 1]
                        set c [expr $c + 1]
                    }
                }
            pack $f.attributs.corps -fill x
        pack $f.attributs.liste -side left -fill x
    pack $f.attributs -fill x -padx 10
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command {
            global table_tmp
            set f ".fen_ajout_table"
            set id [dict get $table_tmp "id"]
            dict set table_tmp "nom" [$f.nom.e get]
            dict set table_tmp "description" "À faire..."
            set ok [Katyusha_Tables_controle_table $table_tmp]
            if {$id == "null" && $ok == 1} {
                ajout_table $table_tmp
                destroy $f
            } elseif {$id != "null" && $ok == 1} {
                Katyusha_Tables_modification_table $id $table_tmp
                destroy $f
            }
        }
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command "destroy $f"
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes -fill x
    
    # Titre le la présente fenêtre
    if {$id == "null"} {
        wm title $f $LOCALE(ajouter_une_table)
    } else {
        wm title $f "Éditer la table : $nom_table"
    }
    
    # Mise à jour forcée de l'affichage graphique
    update
}

##
# Fenêtre d'ajout d'un attribut à une table ou une relation
##
proc INTERFACE_ajout_attribut {entite} {
    global table_tmp
    global relation_tmp
    global LOCALE
    global IMG
    
    set f ".fen_ajout_attribut"
    set defaut_valeur "null"
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    # Frame de titre
    frame $f.nom
        label $f.nom.l -text "Propriétés de l'attribut"
        pack $f.nom.l -fill x
    pack $f.nom -fill x -pady 10 -padx 50
    
    # Propriétés de l'attribut
    frame $f.prop
        # Nom de l'attribut
        frame $f.prop.nom
            label $f.prop.nom.l -text "Nom de l'attribut : " -width 40
            entry $f.prop.nom.e
            pack $f.prop.nom.l $f.prop.nom.e -side left -fill x
        pack $f.prop.nom
        # Type de l'attribut
        frame $f.prop.type
            label $f.prop.type.l -text "Type de l'attribut : " -width 40
            ttk::combobox $f.prop.type.cb -values [Katyusha_SQL_liste_types]
            pack $f.prop.type.l $f.prop.type.cb -side left -fill x
        pack $f.prop.type
        # Taille de l'attribut (0 pour la valeur par défaut du SGBD)
        frame $f.prop.taille
            label $f.prop.taille.l -text "Taille de l'attribut : " -width 40
            spinbox $f.prop.taille.sb -from 0 -to 255 -increment 1
            pack $f.prop.taille.l $f.prop.taille.sb -side left -fill x
        pack $f.prop.taille
        label $f.prop.info_taille -text "Attention, tous les type ne possèdent pas de taille. Si c'est le cas, ce paramètre sera simplement ignoré.\nLaisser \"0\" pour utiliser la valeur par défaut du SGBD." -foreground red
        pack $f.prop.info_taille -fill x
        # Valeur par défaut
        frame $f.prop.valeur
            label $f.prop.valeur.l -text "Valeur par défaut de l'attribut : " -width 40
            entry $f.prop.valeur.e -textvariable defaut_valeur
            pack $f.prop.valeur.l $f.prop.valeur.e -side left -fill x
        pack $f.prop.valeur
        # Incrémentation automatique?
        frame $f.prop.auto
            label $f.prop.auto.l -text "Auto incrémentation? : " -width 40
            checkbutton $f.prop.auto.cb -onvalue 1 -offvalue 0 -variable get_auto
            pack $f.prop.auto.l $f.prop.auto.cb -side left -fill x
        pack $f.prop.auto
        # Clef primaire?
        frame $f.prop.pk
            label $f.prop.pk.l -text "Clef primaire? : " -width 40
            checkbutton $f.prop.pk.cb -onvalue 1 -offvalue 0 -variable get_pk
            pack $f.prop.pk.l $f.prop.pk.cb -side left -fill x
        pack $f.prop.pk
    pack $f.prop -fill x
    
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command "INTERFACE_COMMANDE_ajout_attribut $entite"
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command "destroy $f"
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes -fill x
    
    # Titre le la présente fenêtre
    wm title $f "Ajouter un attribut"
    update
}

proc INTERFACE_COMMANDE_ajout_attribut {entite} {
    global get_auto
    global get_pk
    set f ".fen_ajout_attribut"
    if {$entite == "table"} {
        set ok [Katyusha_Tables_controle_attribut [$f.prop.nom.e get] [$f.prop.type.cb get] [$f.prop.taille.sb get] [$f.prop.valeur.e get] $get_auto $get_pk]
        if {$ok == 1} {
            Katyusha_Tables_ajout_attribut [$f.prop.nom.e get] [$f.prop.type.cb get] [$f.prop.taille.sb get] [$f.prop.valeur.e get] $get_auto $get_pk
            destroy $f
        }
    } elseif {$entite == "relation"} {
        set ok [Katyusha_Tables_controle_attribut [$f.prop.nom.e get] [$f.prop.type.cb get] [$f.prop.taille.sb get] [$f.prop.valeur.e get] $get_auto $get_pk]
        if {$ok == 1} {
            Katyusha_Relations_ajout_attribut [$f.prop.nom.e get] [$f.prop.type.cb get] [$f.prop.taille.sb get] [$f.prop.valeur.e get] $get_auto $get_pk
            destroy $f
        }
    }
}

##
#
##
proc INTERFACE_suppression_attribut {entite} {
    global table_tmp
    global relation_tmp
    global LOCALE
    global IMG
    
    set f ".fen_supp_attribut"
    set defaut_valeur "null"
    
    if {$entite == "table"} {
        set attributs [dict get $table_tmp "attributs"]
    } elseif {$entite == "relation"} {
        set attributs [dict get $relation_tmp "attributs"]
    }
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    # Frame de titre
    frame $f.nom
        label $f.nom.l -text "Sélectionner un attribut à supprimer"
        pack $f.nom.l -fill x
    pack $f.nom -fill x -pady 10 -padx 50
    ttk::combobox $f.cb -value $attributs -width 50
    pack $f.cb
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command "INTERFACE_COMMANDE_suppression_attribut $entite"
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command {destroy .fen_supp_attribut}
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes
    
    # Titre le la présente fenêtre
    wm title $f "Supprimer un attribut"
    update
}

proc INTERFACE_COMMANDE_suppression_attribut {entite} {
    global table_tmp
    global relation_tmp
    
    set f ".fen_supp_attribut"
    set attribut_dict [$f.cb get]
    
    if {$attribut_dict != ""} {
        set attribut [dict get $attribut_dict "nom"]

        if {$entite == "table"} {
            set table_tmp [Katyusha_Tables_suppression_attribut_table $table_tmp $attribut]
        } elseif {$entite == "relation"} {
            set relation_tmp [Katyusha_Tables_suppression_attribut_relation $relation_tmp $attribut]
        }
        destroy .fen_ajout_$entite.attributs.corps.$attribut 
        destroy $f
    } else {
        set ok [tk_messageBox -icon error -message "Aucun attribut n'a été sélectionné" -type ok]
    }
    
    update
}

proc INTERFACE_suppression_lien_relation {} {
    global relation_tmp
    global LOCALE
    global IMG
    
    set f ".fen_supp_lien_relation"
    set liens [list]
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    foreach {k lien} [dict get $relation_tmp "liens"] {
        lappend liens "$k : $lien"
    }
    
    # Frame de titre
    frame $f.nom
        label $f.nom.l -text "Sélectionner un lien à supprimer"
        pack $f.nom.l -fill x
    pack $f.nom -fill x -pady 10 -padx 50
    ttk::combobox $f.cb -value $liens -width 50
    pack $f.cb
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command {}
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command {destroy .fen_supp_lien_relation}
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes
    
    # Titre le la présente fenêtre
    wm title $f "Supprimer un lien"
    update
}

##
# Si aucune relation n'est spécifiée en argument, il s'agira d'un ajout de relation.
# Si une relations est passée en argument, il s'agira alors de l'éditer.
# Pour un ajout, spécifier uniquement les coordonnées.
# Pour une édition, indiquer en coordonnées 0:0 et passer son id
##
proc INTERFACE_ajout_relation {x y {id "null"}} {
    global relation_tmp
    global relations
    global tables
    global coords
    global LOCALE
    global IMG
    global id_attribut_graphique
    
    set liste_type_relations [list "0.1" "1.1" "0.n" "1.n" "n.n"]
    
    set f ".fen_ajout_relation"
    
    # Initialise la relation temporaire
    if {$id == "null"} {
        # Transfert des coordonnées
        set coords [list $x $y]
        set relation_tmp [Katyusha_Relations_init_relation]
        dict set relation_tmp "coords" $coords
    } else {
        set relation [dict get $relations $id]
        set relation_tmp $relation
        set nom_relation [dict get $relation "nom"]
    }
    dict set relation_tmp "id" $id
    
    set id_attribut_graphique 0
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    # Frame de choix du nom de la table
    frame $f.nom
        label $f.nom.l -text "Nom de la relation : "
        entry $f.nom.e -textvariable nom_relation
        pack $f.nom.l $f.nom.e -side left
    pack $f.nom -pady 10 -padx 50
    
    ##
    # Liens de la relation
    ##
    frame $f.liens
        # Commandes des liens
        frame $f.liens.commandes
            # Bouton d'ajout d'un nouveau lien
            button $f.liens.commandes.ajout -text "+" -image $IMG(ajouter) -command {INTERFACE_ajout_lien_relation}
            # Bouton de supression d'un lien
            button $f.liens.commandes.supp -text "-" -image $IMG(supprimer) -command {INTERFACE_suppression_lien_relation}
            pack $f.liens.commandes.ajout $f.liens.commandes.supp -padx 10
        pack $f.liens.commandes -side left -fill x
        # Liste des liens
        frame $f.liens.liste
            label $f.liens.liste.titre -text "Liste des liens de la relation"
            pack $f.liens.liste.titre -fill x
            frame $f.liens.liste.tete
                label $f.liens.liste.tete.nom -text "Table concernée" -width 40 -height 2 -background white -relief solid
                label $f.liens.liste.tete.type -text "Type" -width 20 -height 2 -background white -relief solid
                pack $f.liens.liste.tete.nom $f.liens.liste.tete.type -fill x -side left
            pack $f.liens.liste.tete -fill x
            frame $f.liens.liste.corps
                ##
                # Ici viennent s'insérer les liens
                ##
                # Si la relation est en édition, on affiche la liste des liens déjà existants
                if {$id != "null"} {
                    set liens [dict get $relation "liens"]
                    foreach {k lien} $liens {
                        frame $f.liens.liste.corps.$k
                            label $f.liens.liste.corps.$k.table -text [lindex $lien 0] -width 40 -height 2 -background white -relief solid
                            label $f.liens.liste.corps.$k.type -text [lindex $lien 1] -width 20 -height 2 -background white -relief solid
                            pack $f.liens.liste.corps.$k.table $f.liens.liste.corps.$k.type -side left
                        pack $f.liens.liste.corps.$k -fill x
                    }
                }
                # TODO
            pack $f.liens.liste.corps
        pack $f.liens.liste -fill x
    pack $f.liens -fill x -padx 10
    
    ##
    # Attributs de la relation
    ##
    frame $f.attributs
        # Commandes des attributs
        frame $f.attributs.commandes
            # Bouton d'ajout d'un nouvel attribut
            button $f.attributs.commandes.ajout -text "+" -image $IMG(ajouter) -command {INTERFACE_ajout_attribut "relation"}
            # Bouton de supression d'un nouvel attribut
            button $f.attributs.commandes.supp -text "-" -image $IMG(supprimer) -command {INTERFACE_suppression_attribut "relation"}
            pack $f.attributs.commandes.ajout $f.attributs.commandes.supp -padx 10
        pack $f.attributs.commandes -side left -fill x
        # Liste des attributs
        frame $f.attributs.liste
            label $f.attributs.titre -text "Liste des attributs de la relation"
            pack $f.attributs.titre -fill x
            frame $f.attributs.tete
                label $f.attributs.tete.nom -text "Nom" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.type -text "Type" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.taille -text "Taille" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.valeur -text "Valeur par défaut" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.auto -text "Incrément?" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.pk -text "Clef primaire?" -width 20 -height 2 -background white -relief solid
                pack $f.attributs.tete.nom $f.attributs.tete.type $f.attributs.tete.taille $f.attributs.tete.valeur $f.attributs.tete.auto $f.attributs.tete.pk -fill x -side left
            pack $f.attributs.tete -fill x
            frame $f.attributs.corps
                ##
                # Ici viennent s'insérer les attributs
                ##
                # Si la relation est en édition, on affiche la liste des attributs déjà existants
                if {$id != "null"} {
                    set c 0
                    set attributs [dict get $relation "attributs"]
                    foreach attribut $attributs {
                        set nom_attribut_graphique [dict get $attribut "nom"]
                        frame $f.attributs.corps.$nom_attribut_graphique
                            label $f.attributs.corps.$nom_attribut_graphique.nom -text [dict get $attribut "nom"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.type -text [dict get $attribut "type"] -width 20 -height 2 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.taille -text [dict get $attribut "taille"] -width 20 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.valeur -text [dict get $attribut "valeur"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.auto -text [dict get $attribut "auto"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$nom_attribut_graphique.pk -text [dict get $attribut "pk"] -width 20 -height 2 -background white -relief solid
                            button $f.attributs.corps.$nom_attribut_graphique.edit -text "Éditer" -image $IMG(editer) -command "Katyusha_Relations_modification_attribut $c"
                            pack $f.attributs.corps.$nom_attribut_graphique.nom $f.attributs.corps.$nom_attribut_graphique.type $f.attributs.corps.$nom_attribut_graphique.taille $f.attributs.corps.$nom_attribut_graphique.valeur $f.attributs.corps.$nom_attribut_graphique.auto $f.attributs.corps.$nom_attribut_graphique.pk -side left
                        pack $f.attributs.corps.$nom_attribut_graphique -fill x
                        set c [expr $c + 1]
                    }
                }
            pack $f.attributs.corps -fill x
        pack $f.attributs.liste -side left -fill x
    pack $f.attributs -fill x -padx 10
    
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command {
            global relation_tmp
            set f ".fen_ajout_relation"
            set id [dict get $relation_tmp "id"]
            dict set relation_tmp "nom" [$f.nom.e get]
            dict set relation_tmp "description" "À faire..."
            set ok [Katyusha_Relations_controle_relation $relation_tmp]
            if {$id == "null" && $ok == 1} {
                Katyusha_ajout_relation $relation_tmp
                destroy $f
            } elseif {$id != "null" && $ok == 1} {
                Katyusha_Relations_modification_relation $id $relation_tmp
                destroy $f
            }
        }
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command {destroy .fen_ajout_relation}
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes -fill x
    
    # Titre le la présente fenêtre
    if {$id == "null"} {
        wm title $f "Ajouter une relation"
    } else {
        wm title $f "Éditer la relation : $nom_relation"
    }
    
    # Mise à jour forcée de l'affichage graphique
    update
}

proc INTERFACE_ajout_lien_relation {} {
    global relation_tmp
    global tables
    global IMG
    global LOCALE
    
    set f ".fen_ajout_lien_relation"
    
    set liste_type_relations [list "0.1" "1.1" "0.n" "1.n" "n.n"]
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    # Créé la fenêtre 
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    # Choix des tables concernées par la relation
    frame $f.tables
        label $f.tables.info -text "Sélectionner la table concernée par le lien :"
        pack $f.tables.info
        frame $f.tables.tete
            label $f.tables.tete.ct -text "Table" -width 20
            label $f.tables.tete.cr -text "Type de lien" -width 20
            pack $f.tables.tete.ct $f.tables.tete.cr -side left
        pack $f.tables.tete -fill x
        frame $f.tables.r
            ttk::combobox $f.tables.r.ct -values [liste_tables] -width 20
            ttk::combobox $f.tables.r.cr -values $liste_type_relations -width 20
            pack $f.tables.r.ct $f.tables.r.cr -side left
        pack $f.tables.r -fill x
        # Si il y a moins de deux tables, avertir l'utilisateur
        if {[dict size $tables] < 1} {
            label $f.tables.info_err -text "Il n'y a pas assez de tables dans le MCD." -justify left -foreground red
            pack $f.tables.info_err
        }
    pack $f.tables -pady 10 -padx 20
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command "destroy $f"
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes -fill x
}

##
# Fenêtre de configuration de la nouvelle relation à ajouter
# x et y sont les coordonnées où créer l'affichage graphique
##
proc INTERFACE_ajout_relation_a {x y} {
    global relation_tmp
    global tables
    global coords
    global LOCALE
    global IMG
    
    set liste_type_relations [list "0.1" "1.1" "0.n" "1.n" "n.n"]
    
    # Transfert des coordonnées
    set coords [list $x $y]
    set f ".fen_ajout_relation"
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    # Créé la fenêtre 
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    # Frame de choix du nom de la relation
    frame $f.nom
        label $f.nom.l -text "Entrer le nom de la relation :"
        entry $f.nom.e
        pack $f.nom.l $f.nom.e -side left
    pack $f.nom
    # Choix des tables concernées par la relation
    frame $f.tables
        label $f.tables.info -text "Sélectionner les tables concernées par la relation :"
        pack $f.tables.info
        frame $f.tables.r1
            ttk::combobox $f.tables.r1.ct -values [liste_tables]
            ttk::combobox $f.tables.r1.cr -values $liste_type_relations
            pack $f.tables.r1.ct $f.tables.r1.cr -side left
        pack $f.tables.r1 -fill x
        frame $f.tables.r2
            ttk::combobox $f.tables.r2.ct -values [liste_tables]
            ttk::combobox $f.tables.r2.cr -values $liste_type_relations
            pack $f.tables.r2.ct $f.tables.r2.cr -side left
        pack $f.tables.r2 -fill x
        button $f.tables.ajout_r -image $IMG(ajouter)
        pack $f.tables.r1 $f.tables.r2 $f.tables.ajout_r -fill x
        # Si il y a moins de deux tables, avertir l'utilisateur
        if {[dict size $tables] < 2} {
            label $f.tables.info_err -text "Il n'y a pas assez de tables dans le MCD.\nUne relation doit concerner au moins deux tables." -justify left -foreground red
            pack $f.tables.info_err
        }
    pack $f.tables
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command {
            global relation_tmp
            global coords
            set f ".fen_ajout_relation"
            set nom [$f.nom.e get]
            # TODO : balayage des tables sélectionnées
            set liens_tmp [dict create]
            for {set n_cbbox 1} {$n_cbbox <= 2} {incr n_cbbox} {
                set f ".fen_ajout_relation"
                set nom_cbbox_table_liee "$f.tables.r$n_cbbox.ct"
                set nom_cbbox_lien "$f.tables.r$n_cbbox.cr"
                set table_liee [$nom_cbbox_table_liee get]
                set lien [$nom_cbbox_lien get]
                # Ajout du lien
                dict set liens_tmp [expr $n_cbbox - 1] [list $table_liee $lien]
            }
            dict set relation_tmp "nom" $nom
            dict set relation_tmp "coords" $coords
            dict set relation_tmp "liens" $liens_tmp
            destroy $f
            Katyusha_ajout_relation $relation_tmp
            unset coords relation_tmp nom f liens_tmp lien table_liee nom_cbbox_table_liee nom_cbbox_lien
        }
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command {destroy .fen_ajout_relation}
        pack $f.commandes.ok $f.commandes.ko -side left -fill x -padx 50 -pady 10
    pack $f.commandes
    # Titre le la présente fenêtre
    wm title $f "Ajouter une relation entre deux tables"
    # Mise à jour forcée de l'affichage graphique
    update
}

proc INTERFACE_suppression_entite {type_entite id_entite} {
    set rep [tk_messageBox -message "Sure de vouloir supprimer cette $type_entite" -type "yesno"]
    if {$rep == "yes"} {
        if {$type_entite == "table"} {
            suppression_table $id_entite
        } elseif {$type_entite == "relation"} {
            
        }
    }
}

proc INTERFACE_liste_entites {} {
    global relations
    global tables
    global IMG
    global LOCALE
    
    set f ".fen_liste_entites"
    
    set liste_tables [list]
    set liste_relations [list]
    

        foreach {k relation} $relations {
            set nom_relation [dict get $relation "nom"]
            lappend liste_relations "$k : $nom_relation"
        }
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    # Frame de choix du nom de la table
    frame $f.nom
        label $f.nom.l -text "Liste des entités du MCD"
        pack $f.nom.l
    pack $f.nom -pady 10 -padx 50
    ##
    # Liste des entités
    ##
    frame $f.liste
        # Tables
        frame $f.liste.tables
            label $f.liste.tables.l -text "Tables"
            listbox $f.liste.tables.lb -listvariable $liste_tables -height 20 -selectmode browse -yscrollcommand [list $f.liste.st set]
            frame $f.liste.tables.commandes
                button $f.liste.tables.commandes.ajout -text "+" -image $IMG(ajouter) -command "INTERFACE_ajout_table 100 100"
                button $f.liste.tables.commandes.supp -text "-" -image $IMG(supprimer) -command {
                    global tables
                    foreach {k table} $tables {
                        set nom_table [dict get $table "nom"]
                        lappend liste_tables "$k : $nom_table"
                    }
                    INTERFACE_COMMANDE_supprimer_entite "table" $liste_tables
                }
                button $f.liste.tables.commandes.edit -text "/" -image $IMG(editer) -command {
                    global tables
                    foreach {k table} $tables {
                        set nom_table [dict get $table "nom"]
                        lappend liste_tables "$k : $nom_table"
                    }
                    INTERFACE_COMMANDE_editer_entite "table" $liste_tables
                }
                pack $f.liste.tables.commandes.ajout $f.liste.tables.commandes.supp $f.liste.tables.commandes.edit -side left
            pack $f.liste.tables.l $f.liste.tables.lb $f.liste.tables.commandes -fill x
        scrollbar $f.liste.st -orient vertical -command [list $f.liste.tables.lb yview]
        foreach {k table} $tables {
            set nom_table [dict get $table "nom"]
            $f.liste.tables.lb insert end "$k : $nom_table"
        }
        # Relations
        frame $f.liste.relations
            label $f.liste.relations.l -text "Relations"
            listbox $f.liste.relations.lb -listvariable $liste_relations -height 20 -selectmode browse -yscrollcommand [list $f.liste.sr set]
            frame $f.liste.relations.commandes
                button $f.liste.relations.commandes.ajout -text "+" -image $IMG(ajouter) -command "INTERFACE_ajout_table 100 100"
                button $f.liste.relations.commandes.supp -text "-" -image $IMG(supprimer) -command {
                    global relations
                    foreach {k relation} $relations {
                        set nom_relation [dict get $relation "nom"]
                        lappend liste_relations "$k : $nom_relation"
                    }
                    INTERFACE_COMMANDE_supprimer_entite "relation" $liste_relations
                }
                button $f.liste.relations.commandes.edit -text "/" -image $IMG(editer) -command {
                    global relations
                    foreach {k relation} $relations {
                        set nom_relation [dict get $relation "nom"]
                        lappend liste_relations "$k : $nom_relation"
                    }
                    INTERFACE_COMMANDE_editer_entite "relation" $liste_relations
                }
                pack $f.liste.relations.commandes.ajout $f.liste.relations.commandes.supp $f.liste.relations.commandes.edit -side left
            pack $f.liste.relations.l $f.liste.relations.lb $f.liste.relations.commandes -fill x
            pack $f.liste.relations.l $f.liste.relations.lb -fill x
        scrollbar $f.liste.sr -orient vertical -command [list $f.liste.relation.lb yview]
        foreach {k relation} $relations {
            set nom_relation [dict get $relation "nom"]
            $f.liste.relations.lb insert end "$k : $nom_table"
        }
        pack $f.liste.tables $f.liste.st $f.liste.relations $f.liste.sr -side left -fill y
    pack $f.liste
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command "destroy $f"
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command "destroy $f"
        pack $f.commandes.ok $f.commandes.ko -side left -fill x -padx 50 -pady 10
    pack $f.commandes
}

proc INTERFACE_COMMANDE_supprimer_entite {type_entite liste} {
    global tables
    global relations
    
    set f ".fen_liste_entites"
    set entite [$f.liste.$type_entite\s.lb curselection]
    set id_entite [lindex [split [lindex $liste $entite] " : "] 0]
    puts $id_entite
    
    if {$type_entite == "table"} {
        suppression_table $id_entite
    } elseif {$type_entite == "relation"} {
        suppression_relation $id_entite
    }
    update
}

proc INTERFACE_COMMANDE_editer_entite {type_entite liste} {
    global tables
    global relations
    
    set f ".fen_liste_entites"
    set entite [$f.liste.$type_entite\s.lb curselection]
    set id_entite [lindex [split [lindex $liste $entite] " : "] 0]
    puts $entite
    
    if {$type_entite == "table"} {
        INTERFACE_ajout_table 0 0 $id_entite
    } elseif {$type_entite == "relation"} {
        INTERFACE_ajout_relation 0 0 $id_entite
    }
    update
}
