## Créé le 4/7/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################


##
# Donne le chemin du fichier à sauvegarder
##
proc Katyusha_sauvegarder {} {
    global fichier_sauvegarde
    if {$fichier_sauvegarde == ""} {
        #set fichier_sauvegarde [tk_getSaveFile -initialdir "~/Projets/Phosphore/tclproject"]
        #.mcd.infos.fichier configure -text $fichier_sauvegarde
        Katyusha_sauvegarder_sous
    }
    if {$fichier_sauvegarde != ""} {
        Katyusha_Sauvegarde
    }
}

proc Katyusha_sauvegarder_sous {} {
    global fichier_sauvegarde
    set fichier [tk_getSaveFile -initialdir "~/Projets/Phosphore/tclproject"]
    if {$fichier != ""} {
        # Vérifie l'extension du fichier
        set ext [string range $fichier [expr [string length $fichier] - 4] [expr [string length $fichier] - 1]]
        if {$ext != ".mcd"} {
            set fichier_sauvegarde "$fichier.mcd"
        } else {
            set fichier_sauvegarde $fichier
        }
        .mcd.infos.fichier configure -text $fichier_sauvegarde
        if {$fichier_sauvegarde != ""} {
            Katyusha_Sauvegarde
        }
    }
}

##
# Retourne le code XML des configurations de la base sauvegardée
##
proc Katyusha_Sauvegarde_base {} {
    global MCD
    
    set xml "<base>\n\t<nom>$MCD(nom)</nom>\n\t<sgbd>$MCD(sgbd)</sgbd>\n\t<drop>$MCD(drop)</drop>\n</base>\n"
    return $xml
}

##
# 
##
proc Katyusha_Sauvegarde_table {id table} {
    set nom_table [dict get $table nom]
    set xml "\t<table id=$id>\n\t\t<nom>$nom_table</nom>\n\t\t<attributs>\n"
    set attributs [dict get $table attributs]
    # Balayage des attributs de la table
    set id_attribut 0
    foreach kb $attributs {
        set id_attribut [expr $id_attribut + 1]
        set nom_attribut [dict get $kb nom]
        set xml "$xml\t\t\t<attribut id=$id_attribut>\n\t\t\t\t<nom>$nom_attribut</nom>\n"
        set type [dict get $kb type]
        set xml "$xml\t\t\t\t<type>$type</type>\n"
        set pk [dict get $kb pk]
        set xml "$xml\t\t\t\t<pk>$pk</pk>\n"
        set pk [dict get $kb taille]
        set xml "$xml\t\t\t\t<taille>$pk</taille>\n"
        set auto [dict get $kb auto]
        set xml "$xml\t\t\t\t<auto_increment>$auto</auto_increment>\n"
        set valeur [dict get $kb valeur]
        set xml "$xml\t\t\t\t<valeur>$valeur</valeur>\n"
        set xml "$xml\t\t\t</attribut>\n"
    }
    # Coordonnées de la table graphique
    set coords [dict get $table coords]
    set x [lindex $coords 0]
    set y [lindex $coords 1]
    # Description de la table
    set description [dict get $table description]
    set xml "$xml\t\t\t<description>$description</description>\n"
    set xml "$xml\t\t</attributs>\n\t<coords>$x/$y</coords>\n\t</table>\n"
    return $xml
}

##
# Retourne le code XML de l'ensemble des tables
##
proc Katyusha_Sauvegarde_tables {tables} {
    set xml "<tables>\n"
    # Balayage des tables
    foreach {ka table} $tables {
        set xml "$xml[Katyusha_Sauvegarde_table $ka $table]"
    }
    set xml "$xml</tables>\n"
    return $xml
}

proc Katyusha_Sauvegarde_relation {id relation} {
    set nom_relation [dict get $relation nom]
    set xml "\t<relation id=$id>\n\t\t<nom>$nom_relation</nom>\n\t\t<liens>\n"
    set liens [dict get $relation liens]
    # Balyage des liens
    foreach {k lien} $liens {
        set table_lien [lindex $lien 0]
        set n_lien [lindex $lien 1]
        set xml "$xml\t\t\t<lien id=$k>\n"
        set xml "$xml\t\t\t\t<table_lien>$table_lien</table_lien>\n\t\t\t\t<n_lien>$n_lien</n_lien>\n"
        set xml "$xml\t\t\t</lien>\n"
    }
    # Coordonnées de la table graphique
    set coords [dict get $relation coords]
    set x [lindex $coords 0]
    set y [lindex $coords 1]
    set xml "$xml\t\t</liens>\n\t<coords>$x/$y</coords>\n\t</relation>\n"
    return $xml
}

##
# Retourne le code XML de l'ensemble des relations
##
proc Katyusha_Sauvegarde_relations {relations} {
    set xml "<relations>\n"
    # Balayage des relations
    foreach {ka relation} $relations {
        set xml "$xml[Katyusha_Sauvegarde_relation $ka $relation]"
    }
    set xml "$xml</relations>\n"
    return $xml
}

##
# Retourne le code XML de l'ensemble des héritages
# TODO : tout
##
proc Katyusha_Sauvegarde_heritages {heritages} {
    set xml ""
    return $xml
}

##
# Enregistre toutes les données dans un fichier au format XML
# TODO : enregistrement des héritages
##
proc Katyusha_Sauvegarde {} {
    global tables
    global relations
    global heritages
    global fichier_sauvegarde
    global version
    
    set xml ""
    # En tête XML
    set xml "$xml<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<katyusha>\n\t<version>$version</version>\n</katyusha>\n"
    # Enregistrement des configurations de la base
    set xml "$xml[Katyusha_Sauvegarde_base]"
    # Enregistrement des tables
    set xml "$xml[Katyusha_Sauvegarde_tables $tables]"
    # Enregistrement des relations
    set xml "$xml[Katyusha_Sauvegarde_relations $relations]"
    # Enregistrement des héritages
    # TODO
    set xml "$xml[Katyusha_Sauvegarde_heritages $heritages]"
    # Enregistre dans le fichier
    set stream [open $fichier_sauvegarde "w+"]
    puts $stream $xml
    close $stream
    puts "MCD sauvegarder sous : $fichier_sauvegarde"
    # Met à jour les dictionnaires de sauvegarde
    Katyusha_MAJ_SC
}
